/*

  http://www.hmgforum.com/viewtopic.php?f=5&t=238&p=1438&hilit=color#p1438

  MINIGUI - Harbour Win32 GUI library Demo/Sample
 
  Copyright 2002-07 Roberto Lopez <roblez@ciudad.com.ar>
  http://www.geocities.com/harbour_minigui/
 
  Color Codes is a freevare program for easly 
  selecting color codes with decimal and hexadecimal values. 
  
  Without changing and modifying any vay, 
  using and distributing is totally free.

  All bug reports and suggestions are welcome.
    
  Developed under Harbour Compiler and 
  MINIGUI - Harbour Win32 GUI library (HMG). 
  
  Thanks to "Le Roy" Roberto Lopez.
 
  Copyright 2007 Bicahi Esgici <esgici@gmail.com>
 
  History :
  
     1.2007 : Introduced

  Small Modification of Mustafa Lpez 2019

*/

#include <minigui.ch>

#define NTrim( n )  ( LTrim( STR( n ) ) )

PROC MAIN()

 PRIVATE nControlN :=  0,;        
         nLaButtLN :=  0,;
         cLaButtNo :=  0,;
         nLaBtnRow :=  0,;
         nLaBtnCol :=  0,;
         cLaButNam := '',;
         cSlidrNam := '',;
         cLabelNam := '',;
         cLaBoxNam := '',;
         cSpinrNam := '',;
         nContrRow := 67,;
         nSlidrCol := 50,;
         aMostras  := { { 255, 000, 000 },;    // Red      
                        { 000, 128, 000 },;    // Green   
                        { 000, 000, 255 },;    // Blue
                        { 255, 000, 000 },;       
                        { 000, 128, 000 },;       
                        { 000, 000, 255 } }
                        
    PUBL aBaseClrs := { { 255, 255, 255 },;   // White
                        { 255, 255, 000 },;   // Yellow
                        { 000, 128, 000 },;   // Green
                        { 255, 000, 000 },;   // Red
                        { 000, 000, 255 },;   // Blue
                        { 128, 000, 255 },;   // Violet
                        { 128, 064, 000 },;   // Brune 
                        { 000, 000, 000 } },; // Black
         lSetted  := .F.,;
         cSldrNm  := "Slidr_",;
         cSpnrNm  := "Spinr_",;
         cLaBxNm  := "LaBox_",;    
         aCurrBGC := { 255, 255, 255 },;
         aCurrFGC := { 000, 000, 000 }
         
    PUBL cCurBGHx := Dec2HexCC( aCurrBGC ),;
         cCurFGHx := Dec2HexCC( aCurrFGC )

    PUBL miry1 ,;     // <------- CopyClipboard()     
         miry2 ,;
         miry3 ,;
         miry4 ,;
         miry5 ,;
         miry6 ,;
         pery1 ,;
         pery2 

SET MULTIPLE OFF
SET TOOLTIPSTYLE BALLOON

    DEFINE WINDOW frmColors        ;
       AT  10, 84                  ;
       WIDTH  628                  ; 
       HEIGHT 400                  ; 
       TITLE "Color Codes by Bicahi Esgici" ; 
       ICON 'Logo'                 ;
       MAIN NOSIZE NOMAXIMIZE      ;
       ON INIT DrawBoxs()

       ON KEY ESCAPE ACTION frmColors.Release
       ON KEY CONTROL+C ACTION CopyClipboard()     
  
       FOR nLaButtLN := 1 TO 2
       
          FOR cLaButtNo := 1 TO LEN( aBaseClrs )
          
             cLaButNam := 'LaButt_' + NTrim( nLaButtLN ) + NTrim( cLaButtNo )
             nLaBtnRow := IF( nLaButtLN < 2, nContrRow, nContrRow + 160 ) - 30 
             nLaBtnCol := nSlidrCol + cLaButtNo * 40

             DEFINE LABEL &cLaButNam
                ROW       nLaBtnRow
                COL       nLaBtnCol
                WIDTH     23
                HEIGHT    23
                BACKCOLOR aBaseClrs[ cLaButtNo ]
                ACTION    ChangBase( this.name )
                VALUE ""
             END LABEL
                
          NEXT cLaButtNo
          
       NEXT nLaButtLN
       
       FOR nControlN := 1 TO 6
       
          cSlidrNam := cSldrNm + LTRIM( STR( nControlN ) )
        
          DEFINE SLIDER &cSlidrNam
              ROW      nContrRow
              COL      nSlidrCol
              WIDTH    385
              HEIGHT   27
              RANGEMIN 0
              RANGEMAX 255
              VALUE    IF( nControlN < 4, aCurrBGC[ nControlN ], aCurrFGC[ nControlN - 3] )
              ONCHANGE RefreshCs( this.name, this.value ) 
              NOTICKS  .T.
          END SLIDER
          
          cLabelNam := "Label_" + LTRIM( STR( nControlN ) )
          
          DEFINE LABEL &cLabelNam       // Colores pequeos laterales
              ROW      nContrRow + 7
              COL      nSlidrCol - 20
              WIDTH    20
              HEIGHT   10
              VALUE    ""
              FONTNAME "MS Sans Serif"
              FONTSIZE 9
              FONTBOLD .T.
              FONTITALIC .F.
              BACKCOLOR aMostras[ nControlN ] 
          END LABEL

          cSpinrNam := cSpnrNm + LTRIM( STR( nControlN ) )
          
          DEFINE SPINNER &cSpinrNam
              ROW      nContrRow
              COL      nSlidrCol + 390
              WIDTH    50
              HEIGHT   20
              RANGEMIN 0
              RANGEMAX 255
              VALUE    IF( nControlN < 4, aCurrBGC[ nControlN ], aCurrFGC[ nControlN - 3] )
              FONTNAME "MS Sans Serif"
              ONCHANGE RefreshCs( this.name, this.value )
          END SPINNER
          
          cLaBoxNam := cLaBxNm + LTRIM( STR( nControlN ) )

          DEFINE LABEL &cLaBoxNam             // Cuadrados Color
              ROW      nContrRow - 25
              COL      nSlidrCol + 450
              WIDTH    90
              HEIGHT   40
              VALUE    IF( nControlN = 2, cCurBGHx, IF( nControlN = 5, cCurFGHx, '' ) )
              FONTNAME "MS Sans Serif"
              CENTERALIGN .T.
              TOOLTIP "Copy Clipboard Colors"
              BACKCOLOR aCurrBGC
              FONTCOLOR aCurrFGC
              ACTION CopyClipboard()    
          END LABEL

          nContrRow += IF( nControlN # 3, 30, 100 )
          
       NEXT nControlN 
       
       DEFINE FRAME Frame_1
           ROW    20
           COL    20
           WIDTH  580
           HEIGHT 140
           FONTNAME "MS Sans Serif"
           FONTSIZE 9
           CAPTION "Background"
       END FRAME
       
       DEFINE FRAME Frame_2
           ROW    180
           COL    20
           WIDTH  580
           HEIGHT 140
           FONTNAME "MS Sans Serif"
           FONTSIZE 9
           CAPTION "Foreground"
       END FRAME
  
       DEFINE LABEL Infox
              ROW      337
              COL      030
              WIDTH    300
              HEIGHT   20
              VALUE    "Capture Clipboard Color Codes"+SPACE(3)+ HB_UChar(187) +SPACE(3)+"[ Control ] + C"
              FONTNAME "MS Sans Serif"
              FONTSIZE 9
              FONTBOLD .T.
              FONTITALIC .F.
       END LABEL

       DEFINE BUTTON But_05
              ROW    330
              COL    365 
              WIDTH  105
              HEIGHT 028
              ACTION CopyClipboard()  
              CAPTION  SPACE(02)-"Capture" 
              FONTNAME "Arial"
              FONTSIZE 9
              TOOLTIP "Capture Clipboard"
              FONTBOLD .T.
              FONTITALIC .T.
              PICTURE "Resource\Camara.bmp"
              PICTALIGNMENT  LEFT
       END BUTTON

       DEFINE BUTTON But_06
              ROW    330
              COL    490
              WIDTH  105
              HEIGHT 030
              ACTION  thiswindow.release   
              CAPTION SPACE(5)-"Exit"
              FONTNAME "Arial"
              FONTSIZE 9
              TOOLTIP "Exit"
              FONTBOLD .T.
              FONTITALIC .T.
              PICTURE "Resource/Exit.Bmp"
              PICTALIGNMENT LEFT
    END BUTTON
     
   END WINDOW // Main

   lSetted   := .T.

   SETWINDOWCURSOR ( frmColors.&(cSlidrNam).Handle , "Resource\SmoothHand.cur")
   SETWINDOWCURSOR ( frmColors.&(cLaBoxNam).Handle , "Resource\SmoothHand.cur")
   SETWINDOWCURSOR ( frmColors.But_06.Handle , "Resource\SmoothHand.cur")

   CENTER   WINDOW frmColors 
   ACTIVATE WINDOW frmColors 
   
RETU // Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

*----------------------------------------------------*
PROC CopyClipboard()    
*----------------------------------------------------*

  miry1  := STRTRAN( ALLTRIM(cCurBGHx) , " " ,  "," )   
  miry2  := STRTRAN( ALLTRIM(cCurFGHx) , " " ,  "," )  

  miry3  := STRTRAN( miry1, ",,", ",")
  miry4  := STRTRAN( miry2, ",,", ",")    

  miry5  := STRTRAN( miry3, ",,", ",")    
  miry6  := STRTRAN( miry4, ",,", ",")    

  pery1 := "{" + SPACE(1) + miry5 + SPACE(1) + "}"
  pery2 := "{" + SPACE(1) + miry6 + SPACE(1) + "}"

  System.Clipboard  :=  pery1 + CRLF + pery2

 Msginfo( " BACKCOLOR " + pery1 + CRLF +;
          " FONTCOLOR " + pery2 ,"Capture Clipboard Color Codes")

Return Nil

*----------------------------------------------------*
PROC DrawBoxs()
*----------------------------------------------------*

   LOCA  nLaButtLN :=  0,;
         cLaButtNo :=  0,;
         nLaBtnRow :=  0,;
         nLaBtnCol :=  0,;
         nContrRow := 67,;
         nSlidrCol := 50

   FOR nLaButtLN := 1 TO 2
      
      FOR cLaButtNo := 1 TO LEN( aBaseClrs )
         
         cLaButNam := 'LaButt_' + NTrim( nLaButtLN ) + NTrim( cLaButtNo )
         nLaBtnRow := IF( nLaButtLN < 2, nContrRow, nContrRow + 160 ) - 30 
         nLaBtnCol := nSlidrCol +  cLaButtNo * 40 

         DRAW LINE IN WINDOW frmColors ;
            AT nLaBtnRow,    nLaBtnCol ;
            TO nLaBtnRow,    nLaBtnCol + 23 ; 
            PENCOLOR {245,245,245} ;
            PENWIDTH 2 
            
         DRAW LINE IN WINDOW frmColors ;
            AT nLaBtnRow,    nLaBtnCol ;
            TO nLaBtnRow+23, nLaBtnCol ; 
            PENCOLOR {245,245,245} ;
            PENWIDTH 2 
            
         DRAW LINE IN WINDOW frmColors ;
            AT nLaBtnRow,     nLaBtnCol + 23 ;
            TO nLaBtnRow+23,  nLaBtnCol + 23 ; 
            PENCOLOR { 128, 128, 128 } ;
            PENWIDTH 2 
            
         DRAW LINE IN WINDOW frmColors ;
            AT nLaBtnRow+23,  nLaBtnCol;
            TO nLaBtnRow+23,  nLaBtnCol + 23 ; 
            PENCOLOR { 128, 128, 128 } ;
            PENWIDTH 2 
            
      NEXT cLaButtNo
   NEXT nLaButtLN


RETU // DrawBoxs()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

*----------------------------------------------------*
FUNC Dec2HexCC( aColors )
*----------------------------------------------------*
  LOCA cRVal := ''
 
   AEVAL( aColors, { | n1 | cRVal += NTOC (n1 , 10, 4 ) } )    // <------ Modification by Mustafa Lpez
*  AEVAL( aColors, { | n1 | cRVal += NTOC( n1 , 16, 2 ) } )    // <-----  Original Function by Bicahi Esgici

RETU cRVal // Dec2HexCC()                 

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

*----------------------------------------------------*
PROC RefreshCs( cCntrNam, nCntrVal )
*----------------------------------------------------*
   LOCA cCntrNum := RIGHT( cCntrNam, 1 ) 
   
   LOCA nCntrNum := VAL( cCntrNum ),;
        cOthCntN := '',;
        nLBoxNum := 0,;
        cLaBoxNm := ''
   
   IF lSetted
        
      IF LEFT( cCntrNam, 4 ) == "Slid"
         cOthCntN := cSpnrNm + cCntrNum
      ELSE
         cOthCntN := cSldrNm + cCntrNum
      ENDIF
      
      SetProperty ( "frmColors", cOthCntN, "VALUE", nCntrVal  )
      
      IF nCntrNum < 4
         aCurrBGC[ nCntrNum ] := nCntrVal
      ELSE   
         aCurrFGC[ nCntrNum - 3 ] := nCntrVal
      ENDIF
               
      cCurBGHx := Dec2HexCC( aCurrBGC )
      cCurFGHx := Dec2HexCC( aCurrFGC )
      
      FOR nLBoxNum := 1 TO 6
         cLaBoxNm := "LaBox_" + LTRIM( STR( nLBoxNum ) )
         SetProperty ( "frmColors", cLaBoxNm, "BACKCOLOR", aCurrBGC  )
         SetProperty ( "frmColors", cLaBoxNm, "FONTCOLOR", aCurrFGC  )
         IF nLBoxNum == 2
            SetProperty ( "frmColors", cLaBoxNm, "VALUE", cCurBGHx  )
         ELSEIF nLBoxNum == 5   
            SetProperty ( "frmColors", cLaBoxNm, "VALUE", cCurFGHx  )
         ENDIF         
      NEXT nLBoxNum 
            
   ENDIF lSetted


RETU // RefreshCs()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

*----------------------------------------------------*   
PROC ChangBase( cLaBtNam )   
*----------------------------------------------------*
 LOCA cBasCNo := RIGHT( cLaBtNam, 2 )  
        
 LOCA nCtrlNo := VAL( LEFT( cBasCNo, 1 ) ),;
      nColrNo := VAL( RIGHT( cBasCNo, 1 ) )
        
 LOCA cSpName := '',;   
      cSlName := '',;
      cBxName := '',;
      a1Color := aBaseClrs[ nColrNo ]
        
   FOR nControl := 1 TO 3
      cSpName := cSpnrNm + NTrim( ( nCtrlNo - 1 ) * 3 + nControl )
      cSlName := cSldrNm + NTrim( ( nCtrlNo - 1 ) * 3 + nControl )
      SetProperty ( "frmColors", cSpName, "VALUE", a1Color[ nControl ]  )
      SetProperty ( "frmColors", cSlName, "VALUE", a1Color[ nControl ]  )
      RefreshCs( cSpName, a1Color[ nControl ] )
   NEXT nControl

RETU // ChangBase()
   
*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

